﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public leaf As VueComponent
	Public path As String
	Public name As String = "leaf"
	Private banano As BANano
	Private VLeaflet1 As VLeaflet
End Sub

Sub Initialize(v As VuetifyApp)
	'establish a reference to the app
	vuetify = v
	'initialize the component
	leaf.Initialize(Me, name)
	leaf.vuetify = vuetify
	path = leaf.path
	
	'COMPULSORY
	leaf.ImportLeafLet
	
	'build the page html here
	banano.LoadLayout(leaf.Here, "leafview")
	VLeaflet1.BindState(leaf)
		
	'COMPULSORY - run any method to activate the map
	leaf.SetMounted(Me, "readyleaflet", Null)
	
	'add this route component to the app
	vuetify.AddRoute(leaf)
End Sub	

'COMPULSORY
Sub readyleaflet
	Log("readyleaflet")
	VLeaflet1.UpdateZoom(leaf, 10)	
End Sub

'COMPULSORY
Private Sub VLeaflet1_Ready
	Log("VLeaflet1_Ready")
	vuetify.SetNextTick(Me, "addMarker")
End Sub

'on next refresh
Sub addMarker
	Log("addMarker")
	VLeaflet1.Reset
	
	VLeaflet1.AddMarkerIconColor("ano", "Leaflet Map", 47.413221, -1.619483, VLeaflet1.COLOR_BLACK)
	'VLeaflet1.AddMarkerIcon("ano1", "Ano", 47.313221, -1.319483, "./assets/sponget.png", 42, 42, 4, 30)
	
	VLeaflet1.AddMarkerIcon("ano1", "Ano",47.313221, -1.5, "./assets/sponget.png", 42, 42, 4, 30)
	
	VLeaflet1.AddMarker("1", "Mashy", 47.313221, -1.319483)
	'
	VLeaflet1.AddCircle("2", "Mashy's Circle", 47.41322, -1.0482, "red", 4500)
	'
	VLeaflet1.AddPolygon("3", "Mashy's Polygon", "green")
	
	VLeaflet1.AddPolygonLatLngMap("3", CreateMap(47.2263299: -1.6222, _
	47.21024000000001: -1.6270065, _
	47.1969447: -1.6136169, _
	47.18527929999999: -1.6143036, _
	47.1794457: -1.6098404, _
	47.1775788: -1.5985107, _
	47.1676598: -1.5753365, _
	47.1593731: -1.5521622, _
	47.1593731: -1.5319061, _
	47.1722111: -1.5143967, _
	47.1960115: -1.4841843, _
	47.2095404: -1.4848709, _
	47.2291277: -1.4683914, _
	47.2533687: -1.5116501, _
	47.2577961: -1.5531921, _
	47.26828069: -1.5621185, _
	47.2657179: -1.589241, _
	47.2589612: -1.6204834, _
	47.237287: -1.6266632, _
	47.2263299: -1.6222))
	'
	VLeaflet1.AddPolyLine("4", "Mashy's Polyline", "green")
	VLeaflet1.AddPolyLineLatLngMap("4", CreateMap(47.334852: -1.509485, _
	47.342596: -1.328731, _
	47.241487: -1.190568, _
	47.234787: -1.358337))
	'
	'add a rectangle
	VLeaflet1.AddRectangle("5", "Mashy's Rectangle", 47.341456, -1.397133, 47.303901, -1.243813, "red", 3)
	'
	'VLeaflet1.AddGeoJSON("6", "Mashy's GeoJson", "./assets/communes-pays-de-la-loire.geojson")
	'VLeaflet1.AddGeoJSON("6", "GeoJSON", "https://rawgit.com/gregoiredavid/france-geojson/master/regions/pays-de-la-loire/communes-pays-de-la-loire.geojson")
	
	'always refresh before you setview
	VLeaflet1.Refresh(leaf)
	'show last marker
	'VLeaflet1.SetCenterOnLastPos(leaf)
	'move to explicit position	
	VLeaflet1.SetView(leaf, 47.41322, -1.0482, 9)
End Sub
'
'Private Sub VLeaflet1_UpdateCenter (ll As Object)
'	Log("update_center: " & ll)
'End Sub
'
'Private Sub VLeaflet1_UpdateZoom (ll As Object)
'	Log("update_zoom: " & ll)
'End Sub
'
'Private Sub VLeaflet1_UpdateBounds (bounds As Object)
'	Log("updatebounds: " & bounds)
'End Sub

'COMPULSORY
Private Sub VLeaflet1_Resize
	leaf.refs = vuetify.getrefs
	VLeaflet1.resize(leaf)
End Sub


Private Sub VLeaflet1_ToolBar_Click (id As String)
	Select Case id
	Case "refresh"
		vuetify.pagepause
		addMarker
		vuetify.pageresume	
	End Select
End Sub

Private Sub VLeaflet1_MarkerClick (marker As Map)
	vuetify.ShowSwalInfo(banano.ToJson(marker))
End Sub